package SudokuNvariabel;

public class Sudoku 
{
  int [][] f=new int[9][9];
  int Schwierigkeit;

  void init()
  {
    int n=3;
    for (int i = 0; i < n*n; i++)
      for (int j = 0; j < n*n; j++)
        f[i][j] = (i*n + i/n + j) % (n*n) + 1;
  }
  
  
  void generate()
  {
    init();
    for(int i=1;i<9;i++)  
      permute(i,(int)(Math.random()*9+1));
    if(Math.random()<.3) zeilentausch(0,1);
    if(Math.random()<.3) zeilentausch(1,2);
    if(Math.random()<.3) zeilentausch(0,2);
    if(Math.random()<.3) zeilentausch(3,4);
    if(Math.random()<.3) zeilentausch(4,5);
    if(Math.random()<.3) zeilentausch(3,5);
    if(Math.random()<.3) zeilentausch(6,7);
    if(Math.random()<.3) zeilentausch(7,8);
    if(Math.random()<.3) zeilentausch(6,8);
    
    if(Math.random()<.3) spaltentausch(0,1);
    if(Math.random()<.3) spaltentausch(1,2);
    if(Math.random()<.3) spaltentausch(0,2);
    if(Math.random()<.3) spaltentausch(3,4);
    if(Math.random()<.3) spaltentausch(4,5);
    if(Math.random()<.3) spaltentausch(3,5);
    if(Math.random()<.3) spaltentausch(6,7);
    if(Math.random()<.3) spaltentausch(7,8);
    if(Math.random()<.3) spaltentausch(6,8);
    
  }

  void spaltentausch(int m, int n)
  {
    if(m==n)
      return;
    for(int i=0;i<9;i++)
    {
      int t=f[i][m];
      f[i][m]=f[i][n];
      f[i][n]=t;
    }
  }
  
  void zeilentausch(int m, int n)
  {
    if(m==n)
      return;
    for(int i=0;i<9;i++)
    {
      int t=f[m][i];
      f[m][i]=f[n][i];
      f[n][i]=t;
    }
  }

  boolean check()
  {
    for(int i=0;i<9;i++)
    {
      int sum=0;
      for(int j=0;j<9;j++)
        sum+=f[i][j];
      if(sum!=45)
        return false;
    }
    for(int i=0;i<9;i++)
    {
      int sum=0;
      for(int j=0;j<9;j++)
        sum+=f[j][i];
      if(sum!=45)
        return false;
    }
    for(int i=1;i<9;i+=3)
    {
      for(int j=1;j<9;j+=3)
      {
        int sum=f[i][j];
//        System.out.print(i+" "+j+" "+sum+" ");
        sum+=f[i][j+1];sum+=f[i+1][j+1];sum+=f[i+1][j];sum+=f[i+1][j-1];sum+=f[i][j-1];sum+=f[i-1][j-1];sum+=f[i-1][j];sum+=f[i-1][j+1];
        if(sum!=45)
          return false;
      }
//      System.out.println();
    }
    
    return true;
  }
  
  
  
  void permute(int n, int m)
  {
    if(n==m)
      return;
    for(int i=0;i<9;i++)
      for(int j=0;j<9;j++)
      {
        boolean set=false;
        if(f[i][j]==n)
        {
          f[i][j]=m;
          set=true;
        }
        if(f[i][j]==m && !set)
          f[i][j]=n;        
      }
  }
  
}
