package SudokuNvariabel;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import javax.swing.JPanel;

@SuppressWarnings("serial")
public class GPanel extends JPanel  implements MouseListener, MouseMotionListener
{
	int breite;
    int hoehe ;
    abWrapper ab;
    boolWrapper bw;
    int x=0,y=0;
    Sudoku feld;
    
    
    GPanel(int breite,int hoehe,abWrapper ab,boolWrapper bw, Sudoku feld)
    {
    	this.breite=breite;
    	this.hoehe=hoehe;
    	this.ab=ab;
    	this.bw=bw;
        this.addMouseListener(this);
        this.addMouseMotionListener(this);
        this.feld=feld;
    }
    
    @Override
    public Dimension getPreferredSize() 
    {
        return new Dimension(ab.a, ab.a);
    }

    @Override
    public void paintComponent(Graphics g) 
    {
    	int sdim=feld.dim;
    	super.paintComponent(g);
    	if(bw.beschr)
    		super.paintComponent(g);
    	
    	g.setColor(Color.black);
    	int delta=(int) (this.getSize().getHeight()/sdim/sdim);
		for(int i=0;i<sdim*sdim+1;i++)
		{
			g.drawLine(delta*i,        0, 		delta*i,						  (int) this.getSize().getHeight());
			if(i%sdim==0)
			{
				g.drawLine(delta*i+1,        0+1, 		delta*i+1,						  (int) this.getSize().getHeight()+1);
				g.drawLine(delta*i+2,        0+2, 		delta*i+2,						  (int) this.getSize().getHeight()+2);
			}
			g.drawLine(   0, 		delta*i,(int) this.getSize().getHeight(),       delta*i);
			
			if(i%sdim==0)
			{
				g.drawLine(   0+1, 		delta*i+1,(int) this.getSize().getHeight()+1,       delta*i+1);
				g.drawLine(   0+2, 		delta*i+2,(int) this.getSize().getHeight()+2,       delta*i+2);
			}
		}
		
		g.setFont(new Font("Arial",Font.PLAIN,getFont(sdim)));    	
		for(int i=0;i<sdim*sdim;i++)
			for(int j=0;j<sdim*sdim;j++)
				if(feld.f[i][j]>0)
					g.drawString(feld.f[i][j]+"", j*delta+getshiftx(sdim), i*delta+getshifty(sdim));
		
		g.setColor(Color.darkGray);
		for(int i=0;i<sdim*sdim;i++)
			for(int j=0;j<sdim*sdim;j++)
				if(ab.b==feld.f[i][j] && feld.f[i][j]>0)
					g.fillRect(j*delta, i*delta, delta, delta);

		g.setColor(Color.white);
		g.setFont(new Font("Arial",Font.BOLD,getFont(sdim)));
		for(int i=0;i<sdim*sdim;i++)
			for(int j=0;j<sdim*sdim;j++)
				if(ab.b==feld.f[i][j] && feld.f[i][j]>0)
					g.drawString(feld.f[i][j]+"", j*delta+getshiftx(sdim), i*delta+getshifty(sdim));
		
				
    }//paintComponent

    int getshifty(int n)
    {
    	if(n==2)
    		return 90;
    	if(n==3)
    		return 40;
    	if(n==4)
    		return 20;
    	if(n==5)
    		return 15;
    	return 0;
    }
    
    int getshiftx(int n)
    {
    	if(n==2)
    		return 70;
    	if(n==3)
    		return 30;
    	if(n==4)
    		return 15;
    	if(n==5)
    		return 10;
    	return 0;
    }
    
    int getFont(int n)
    {
    	if(n==2)
    		return 30;
    	if(n==3)
    		return 20;
    	if(n==4)
    		return 14;
    	if(n==5)
    		return 10;
    	return 0;
    }
    
	@Override
	public void mouseDragged(MouseEvent e) 
	{
	}

	@Override
	public void mouseMoved(MouseEvent e) 
	{
//		x=e.getX();
//		y=e.getY();
//		this.repaint();
	}

	@Override
	public void mouseClicked(MouseEvent e) 
	{
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
	
	
}
